/*
ID: espr1t
TASK: Ragain
KEYWORDS: Medium, Binary Search, Sweepline
*/

#include <cstdio>
#include <map>
#include <algorithm>

using namespace std;
FILE *in = stdin, *out = stdout;

const int MAX = 100004;

struct Point {
    int x, y;
    bool operator < (const Point& r) const {
        return x != r.x ? x < r.x : y < r.y;
    }
};

int n;
int l, w, h;
Point cur[MAX];
Point points[MAX];

int atLeastH;
map <int, int> yCoords;

void updateCoord(int y, int value) {
    yCoords[y] += value;
    map <int, int> :: iterator it = yCoords.find(y);
    if (it->second != 0 && it->second - value != 0)
        return;
    int lower, upper;
    it--; lower = y - it->first; it++;
    it++; upper = it->first - y; it--;
    atLeastH += ((lower >= h) + (upper >= h) - (lower + upper >= h)) * value;
    if (it->second == 0)
        yCoords.erase(it);
}

bool covered(int size) {
    memcpy(cur, points, size * sizeof(points[0]));
    sort(cur, cur + size);
    
    atLeastH = (l >= h);
    yCoords.clear(); yCoords[0] = 1, yCoords[l] = 1;
    
    int xPosition = 0, idx = 0;
    for (int i = 0; i < size; i++) {
        if (cur[i].x - w >= xPosition)
            return false;
        
        updateCoord(cur[i].y, +1);
        while (atLeastH == 0) {
            xPosition = cur[idx].x;
            while (idx <= i && cur[idx].x <= xPosition)
                updateCoord(cur[idx++].y, -1);
        }
        if (xPosition + w > l)
            return true;
    }
    return false;
}

int solve() {
    if (!covered(n)) {
        return -1;
    }
    int left = 1, right = n;
    while (left <= right) {
        int mid = (left + right) / 2;
        if (covered(mid))
            right = mid - 1;
        else
            left = mid + 1;
    }
    return right + 1;
}

int main(void) {
//    in = fopen("Ragain.in", "rt");

    fscanf(in, "%d %d %d %d", &n, &l, &w, &h);
    for (int i = 0; i < n; i++)
        fscanf(in, "%d %d", &points[i].x, &points[i].y);
    fprintf(out, "%d\n", solve());

    return 0;
}
