/*
ID: espr1t
TASK: Ragain
KEYWORDS: Easy, Slow, Bruteforce
*/

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;
FILE *in = stdin, *out = stdout;

const int MAX = 100004;

int n;
int l, w, h;
int points[MAX][2];

int solve() {
    vector <long long> x, y;
    x.push_back(w), y.push_back(h);
    
    for (int i = 0; i < n; i++) {
        if (points[i][0] + w <= l)
            x.push_back(points[i][0] * 2LL + w);
        if (points[i][1] + h <= l)
            y.push_back(points[i][1] * 2LL + h);
    }
    sort(x.begin(), x.end());
    x.resize(unique(x.begin(), x.end()) - x.begin());
    sort(y.begin(), y.end());
    y.resize(unique(y.begin(), y.end()) - y.begin());
    
    vector < pair <long long, long long> > candid;
    for (int i = 0; i < (int)x.size(); i++)
        for (int c = 0; c < (int)y.size(); c++)
            candid.push_back(make_pair(x[i], y[c]));
    
    for (int i = 0; i < n; i++) {
        int idx = 0;
        for (int c = 0; c < (int)candid.size(); c++) {
            if (points[i][0] * 2LL - w >= candid[c].first ||
                points[i][0] * 2LL + w <= candid[c].first ||
                points[i][1] * 2LL - h >= candid[c].second ||
                points[i][1] * 2LL + h <= candid[c].second) {
                    candid[idx++] = candid[c];
            }
        }
        candid.resize(idx);
        if (candid.empty())
            return i + 1;
    }
    return -1;
}

int main(void) {
//    in = fopen("Ragain.in", "rt");

    fscanf(in, "%d %d %d %d", &n, &l, &w, &h);
    for (int i = 0; i < n; i++)
        fscanf(in, "%d %d", &points[i][0], &points[i][1]);
    fprintf(out, "%d\n", solve());

    return 0;
}
